
/******************************************************************************
* MODULE     : modular.hpp
* DESCRIPTION: very crude modulo p arithmetic
* COPYRIGHT  : (C) 2005  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "modular.hpp"

namespace mmx {

nat
invert_modulo (nat i, nat p) {
  long_int u1=1, u2=0, u3=p;
  long_int v1=0, v2=1, v3=i;
  while (v3 != 0) {
    long_int q= u3/v3;
    long_int t1= u1- v1*q, t2= u2- v2*q, t3= u3- v3*q;
    u1= v1; u2= v2; u3= v3;
    v1= t1; v2= t2; v3= t3;
  }
  return u2>=0? u2: u2+p;
}

} // namespace mmx
