
/******************************************************************************
* MODULE     : mmx_gmp.hpp
* DESCRIPTION: Interface to gmp and mpfr
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_GMP_HPP
#define __MMX_GMP_HPP
#include <gmp.h>
#include "basix.hpp"

namespace mmx {

#define BITS_PER_LIMB __GMP_BITS_PER_MP_LIMB
#define DEFAULT_LOW   __GMP_BITS_PER_MP_LIMB

inline void mpz_mul_2si (mpz_t dest, const mpz_t arg, long int shift) {
  if (shift >= 0) mpz_mul_2exp (dest, arg, shift);
  else mpz_fdiv_q_2exp (dest, arg, -shift);
}
inline void mpq_mul_2si (mpq_t dest, const mpq_t arg, long int shift) {
  if (shift >= 0) mpq_mul_2exp (dest, arg, shift);
  else mpq_div_2exp (dest, arg, -shift);
}

}
#endif // __MMX_GMP_HPP
